<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axiom.om.OMFactory" %>
<%@ page import="org.apache.axiom.om.OMElement" %>
<%@ page import="org.apache.axiom.om.OMAbstractFactory" %>
<%@ page import="java.io.PrintWriter" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.humantask.ui.HIPackageManagementServiceClient" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.management.types.DeployedPackagesPaginated" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.management.types.TasksInPackage" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.management.types.Package_type0" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.management.types.Task_type0" %>
<%
    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    Log log = LogFactory.getLog("task.deploy.ajaxprocessor");
    Integer pageNumber = (Integer) session.getAttribute("pkgpageNumber");
    if (pageNumber == null || pageNumber < 0) {
        pageNumber = 0;
    }

    HIPackageManagementServiceClient client;
    DeployedPackagesPaginated deployedPackages;
    Task_type0[] tasks;
    OMFactory factory = OMAbstractFactory.getOMFactory();
    OMElement root = factory.createOMElement("PackagesOnPage", null);
    String operation = request.getParameter("operation");

    if (operation != null && operation.toLowerCase().equals("packages")) {
        try {
            client = new HIPackageManagementServiceClient(configContext, backendServerURL, cookie);
        } catch (Exception e) {
            log.error("HI Package Management Service Client Creation Failed.", e);
            PrintWriter pw = response.getWriter();
            pw.write(root.toString());
            pw.flush();
            return;
        }

        while (pageNumber >= 0)  {
            try {
                deployedPackages = client.listDeployedPackagesPaginated(pageNumber);
            } catch (Exception e) {
                log.error("listDeployedPackagesPaginated Operation Failed.", e);
                PrintWriter pw = response.getWriter();
                pw.write(root.toString());
                pw.flush();
                return;
            }

            if (deployedPackages != null && deployedPackages.get_package() != null &&
                    deployedPackages.get_package().length > 0 && deployedPackages.get_package()[0] != null) {
                for (Package_type0 deployedPackage : deployedPackages.get_package()) {
                    String taskList = "";
                    OMElement hiPackage = factory.createOMElement("Package", null, root);
                    tasks = client.listTasksInPackage(deployedPackage.getName());
                    OMElement name = factory.createOMElement("Name", null, hiPackage);
                    name.setText(deployedPackage.getName());
                    if(tasks != null && tasks.length > 0 ){
                        for (Task_type0 task : tasks) {
                            taskList += "<a href='task_view.jsp?tid="+task.getName() +"'>"+task.getName()+ "</a>, ";
                        }
                    } else {
                        taskList = " , ";
                    }
                    //TODO what about task type
                    taskList = taskList.substring(0, taskList.length() - 2);
                    OMElement processesEle = factory.createOMElement("Tasks", null, hiPackage);
                    processesEle.setText(taskList);
                    OMElement packageStatusEle = factory.createOMElement("Status", null, hiPackage);
                    packageStatusEle.setText(deployedPackage.getState().getValue());

                }
                OMElement numPagesEle = factory.createOMElement("Pages", null, root);
                numPagesEle.setText(Integer.toString(deployedPackages.getPages()));
                OMElement pageNumEle = factory.createOMElement("PageNumber", null, root);
                pageNumEle.setText(Integer.toString(pageNumber));
                break;
            } else {
                pageNumber--;
                session.setAttribute("pkgpageNumber", pageNumber);
            }
        }

        if (pageNumber < 0) {
            OMElement numPagesEle = factory.createOMElement("Pages", null, root);
            numPagesEle.setText("0");
        }

    } else {
        PrintWriter pw = response.getWriter();
        pw.write(root.toString());
        pw.flush();
        return;
    }
    request.setCharacterEncoding("UTF-8");
    // Set content to xml
    response.setContentType("text/xml; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    PrintWriter pw = response.getWriter();
    pw.write(root.toString());
    pw.flush();


%>
