<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="java.rmi.RemoteException" %>
<%@ page import="org.wso2.carbon.humantask.ui.TaskDispatcherAdminClient" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.dispatch.XMLStreamExceptionException" %>
<%@ page import="org.wso2.carbon.humantask.ui.task.dispatch.IllegalStateFaultException" %>
<%@ page contentType="application/json" %>
<%@ page pageEncoding="UTF-8" %>
<fmt:bundle basename="org.wso2.carbon.humantask.ui.i18n.Resources">
<%
    Log log = LogFactory.getLog("task.dispatch.ajaxprocessor");

//    request.setCharacterEncoding("UTF-8");
    // Set content to xml
//    response.setContentType("application/json; charset=UTF-8");       
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    String getMyTasksError = "Error occurred during dispatch operation.";
    TaskDispatcherAdminClient client;
    String feedback;

    String taskID = request.getParameter("taskID").trim();
    String soapBody = request.getParameter("payload").trim();

    if (taskID == null || soapBody == null) {
        String errMsg = "Task ID or SoapBody is null";
        log.error(errMsg);
        pageContext.setAttribute("error", errMsg);
        %>
            <p id="ERRORDIALOG"><fmt:message key="taskid.soapbody.null"/><br/></p>
        <%
        return;
    }
    
    try {
        client = new TaskDispatcherAdminClient(configContext, backendServerURL, cookie);
    } catch (AxisFault e) {
        String errMsg = "Error occurred during TaskDispatcherAdminClient creation.";
        log.error(errMsg, e);
        pageContext.setAttribute("error", errMsg);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.create.client"/><br/></p>
        <%
        return;
    }

    try {
        feedback = client.dispatch(taskID, soapBody);
        %>
            <p id="INFODIALOG"><%=feedback%><br/></p>
        <%
    } catch (XMLStreamExceptionException e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.dispatch.operation"/><br/><%=e.toString()%></p>
        <%
    } catch (IllegalStateFaultException e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.dispatch.operation"/><br/><%=e.toString()%></p>
        <%
    } catch (RemoteException e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.dispatch.operation"/><br/><%=e.toString()%></p>
        <%
    } catch (Exception e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
        %>
            <p id="ERRORDIALOG"><fmt:message key="error.dispatch.operation"/><br/><%=e.toString()%></p>
        <%
    }
%>

</fmt:bundle>