<%@ taglib prefix="json" uri="http://www.atg.com/taglibs/json" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.commons.logging.Log" %>
<%@ page import="org.apache.commons.logging.LogFactory" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.humantask.ui.HumanTaskOperationsClient" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalArgumentFault" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalStateFault" %>

<%--TODO : Removed this as the new wsdl does not contain this method.. Should we add it?--%>
<%--<%@ page import="org.wso2.carbon.humantask.ui.api.types.GetMyTaskAbstractsPaginatedResponse" %>--%>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="java.rmi.RemoteException" %>
<%@ page import="org.wso2.carbon.humantask.ui.api.IllegalOperationFault" %>
<%@ page contentType="application/json" %>
<%@ page pageEncoding="UTF-8" %>
<%
    Log log = LogFactory.getLog("task.list.ajaxprocessor");

//    request.setCharacterEncoding("UTF-8");
    // Set content to xml
//    response.setContentType("application/json; charset=UTF-8");
    // Set standard HTTP/1.1 no-cache headers.
    response.setHeader("Cache-Control",
            "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    String backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);

    String taskType = "";
    String genericHumanRole = "";
    String workQueue = "";
    String whereClause = "";
    String orderBy = "";
    String createdOnClause = "";
    String pageNumber = "0";

    if(request.getParameter("taskType") != null){
        taskType = request.getParameter("taskType").trim();
    } else{
        taskType = "ALL";
    }

    if(request.getParameter("genericHumanRole") != null){
        genericHumanRole = request.getParameter("genericHumanRole").trim();
    }

    if(request.getParameter("workQueue") !=null){
        workQueue = request.getParameter("workQueue").trim();
    }

    if(request.getParameter("whereClause")!=null){
        whereClause = request.getParameter("whereClause").trim();
    }

    if(request.getParameter("orderBy") != null){
        orderBy = request.getParameter("orderBy").trim();
    }

    if(request.getParameter("createdOnClause") !=null){
        createdOnClause = request.getParameter("createdOnClause").trim();
    }

    if(request.getParameter("page") !=null){
        pageNumber = request.getParameter("page").trim();
    }


    String getMyTasksError = "Error occurred during getMyTaskAbstracts operation.";
    HumanTaskOperationsClient client;
    //GetMyTaskAbstractsPaginatedResponse taskAbstracts;
    org.wso2.carbon.humantask.ui.api.types.TTaskAbstract[] taskAbstractArray;


    try {
        client = new HumanTaskOperationsClient(configContext, backendServerURL, cookie);
    } catch (AxisFault e) {
        String errMsg = "Error occurred during HumanTaskOperationsClient creation.";
        log.error(errMsg, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    }

    try {
        //taskAbstracts = client.getMyTaskAbstractsPaginated(taskType, genericHumanRole, workQueue, null, whereClause, createdOnClause, 6, Integer.parseInt(pageNumber));
        taskAbstractArray = client.getMyTaskAbstracts(taskType, genericHumanRole, workQueue, null,whereClause, orderBy, createdOnClause, 20, 0);
    } catch (IllegalArgumentFault e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    } catch (IllegalStateFault e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    } catch (RemoteException e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    }  catch (IllegalOperationFault e) {
        log.error(getMyTasksError, e);
        pageContext.setAttribute("error", getMyTasksError);
%>
<json:object>
    <json:property name="error" value="${error}"/>
</json:object>
<%
        return;
    }

    if(Integer.parseInt(pageNumber) >= 0){
        //TODO -> Change this so we have proper pagination.
        pageContext.setAttribute("pages", 1);

        //TODO -> Change this so we have proper pagination.
        pageContext.setAttribute("currentPage", 0);

        //pageContext.setAttribute("taskAbstracts", taskAbstracts.getTaskAbstracts().getTaskAbstract());
        pageContext.setAttribute("taskAbstracts", taskAbstractArray);
%>
<json:object>
    <json:property name="pages" value="${pages}"/>
    <json:property name="currentPage" value="${currentPage}"/>
    <json:array name="tasks" var="task" items="${taskAbstracts}">
        <json:object>
            <json:property name="id" value="${task.id}"/>
            <json:property name="type" value="${task.taskType}"/>
            <json:property name="status" value="${task.status}"/>
            <json:property name="priority" value="${task.priority}"/>
            <json:property name="name" value="${task.presentationName}"/>
            <json:property name="subject" value="${task.presentationSubject}"/>
            <json:property name="created" value="${task.createdTime}"/>
            <json:property name="due" value="${task.expirationTime}"/>
            <%--<json:property name="owner" value="${task.actualOwner}"/>--%>
            <json:property name="responseService" value="${task.responseServiceName}"/>
            <json:property name="responseOperation" value="${task.responseOperationName}"/>
            <json:property name="isClaimable" value="${task.isClaimable}"/>
            <json:property name="isStartable" value="${task.isStartable}"/>
            <json:property name="isStopable" value="${task.isStopable}"/>
            <json:property name="isReleasable" value="${task.isReleasable}"/>
            <%--<json:property name="isSuspendable" value="${task.isSuspendable}"/>--%>
            <%--<json:property name="isResumable" value="${task.isResumable}"/>--%>
            <json:property name="isCompletable" value="${task.isCompletable}"/>
            <%--<json:property name="isRemovable" value="${task.isRemovable}"/>--%>
            <%--<json:property name="isForwardable" value="${task.isForwardable}"/>--%>
            <%--<json:property name="isDelegatable" value="${task.isDelegatable}"/>--%>
        </json:object>
    </json:array>
</json:object>
<%
        return;
    }else{
%>
<json:object>
    <json:property name="error" value="Invalid page number."/>
</json:object>
<%
        return;
    }
%>