<!--
 ~ Copyright (c) 2005-2010, WSO2 Inc. (http://www.wso2.org) All Rights Reserved.
 ~
 ~ WSO2 Inc. licenses this file to you under the Apache License,
 ~ Version 2.0 (the "License"); you may not use this file except
 ~ in compliance with the License.
 ~ You may obtain a copy of the License at
 ~
 ~    http://www.apache.org/licenses/LICENSE-2.0
 ~
 ~ Unless required by applicable law or agreed to in writing,
 ~ software distributed under the License is distributed on an
 ~ "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 ~ KIND, either express or implied.  See the License for the
 ~ specific language governing permissions and limitations
 ~ under the License.
 -->
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar" prefix="carbon" %>
<%@ page import="org.wso2.carbon.humantask.ui.HumanTaskOperationsClient" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.AxisFault" %>
<%@ page import="org.apache.http.HttpStatus" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<carbon:breadcrumb
        label="humantask.newpackage"
        resourceBundle="org.wso2.carbon.humantask.ui.i18n.Resources"
        topPage="true"
        request="<%=request%>"/>
<%
    String backEndServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
    ConfigurationContext configContext =
            (ConfigurationContext) config.getServletContext().getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);

    String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);
    response.setHeader("Cache-Control", "no-store, max-age=0, no-cache, must-revalidate");

    // Set IE extended HTTP/1.1 no-cache headers.
    response.addHeader("Cache-Control", "post-check=0, pre-check=0");

    // Set standard HTTP/1.0 no-cache header.
    response.setHeader("Pragma", "no-cache");

    HumanTaskOperationsClient client;
    org.wso2.carbon.humantask.ui.api.types.TTaskAbstract[] taskAbstractArray;

    try {
        client = new HumanTaskOperationsClient(configContext, backEndServerURL, cookie);
        taskAbstractArray = client.getMyTaskAbstracts(HumanTaskOperationsClient.TASK_TYPE_ALL, null, "", null,"", "", "", 20, 0);
    } catch (Exception e) {
        response.setStatus(HttpStatus.SC_INTERNAL_SERVER_ERROR);
        CarbonUIMessage.sendCarbonUIMessage(e.getMessage(), CarbonUIMessage.ERROR, request, e);
%>
<script type="text/javascript">
    location.href = "../admin/error.jsp";
</script>
<%
        return;
    }
%>
<fmt:bundle basename="org.wso2.carbon.humantask.ui.i18n.Resources">
    <div id="middle">
        <link type="text/css" href="css/ui-lightness/jquery-ui-1.8.custom.css" rel="stylesheet"/>
        <script type="text/javascript" src="js/jquery-1.4.2.min.js"></script>

        <style>
            .flexigrid div.fbutton .add {
                background: url(css/images/add.png) no-repeat center left;
            }

            .flexigrid div.fbutton .delete {
                background: url(css/images/close.png) no-repeat center left;
            }
        </style>
        <script type="text/javascript">
            jQuery(document).ready(function() {
                alternateTableRows('taskList', 'tableEvenRow', 'tableOddRow');
            });
        </script>
        <h2 id="task_list_header"><fmt:message key="ht.task.list"/></h2>

        <div id="workArea">
            <div id="task_list">
                <table class="styledLeft">
                    <thead>
                    <tr>
                        <th><a id="claim" href="#">Claim</a></th>
                        <th><a id="activate" href="#">Activate</a></th>
                        <th></th>
                        <th></th>
                        <th></th>
                        <th></th>
                        <th></th>
                        <th></th>
                        <th></th>
                    </tr>
                    </thead>
                </table>
                <table id="taskList" class="styledLeft">
                    <thead>
                    <tr>
                        <th><fmt:message key="task.id"/></th>
                        <th><fmt:message key="task.name"/></th>
                        <th><fmt:message key="task.presentationSubject"/></th>
                        <th><fmt:message key="task.status"/></th>
                        <th><fmt:message key="task.priority"/></th>
                        <th><fmt:message key="task.createdOn"/></th>
                        <th><fmt:message key="task.expirationTime"/></th>
                        <th><fmt:message key="task.hasAttachments"/></th>
                        <th><fmt:message key="task.hasComments"/></th>
                    </tr>
                    </thead>
                    <tbody>
                    <%
                        if (taskAbstractArray == null || taskAbstractArray.length < 1) {
                    %>
                    <tr>
                        <td colspan="19">No instances available.</td>
                    </tr>
                    <%
                    } else {
                        for (org.wso2.carbon.humantask.ui.api.types.TTaskAbstract tAbs : taskAbstractArray) {
                    %>
                    <tr id="task_<%=tAbs.getId()%>">
                        <td><%=tAbs.getId()%>
                        </td>
                        <td><%=tAbs.getPresentationName()%>
                        </td>
                        <td>
                            <%=tAbs.getPresentationSubject()%>
                        </td>
                        <td>
                            <%=tAbs.getStatus().toString()%>
                        </td>
                        <td>
                            <%=tAbs.getPriority()%>
                        </td>
                        <td>
                            <%--<%=tAbs.getCreatedOn().getTime().toString()%>--%>
                            <%=tAbs.getCreatedTime().getTime().toString()%>
                        </td>
                        <%
                            if (tAbs.getExpirationTime() != null) {
                        %>
                        <td>
                            <%=tAbs.getExpirationTime().getTime().toString()%>
                        </td>
                        <%
                        } else {
                        %>
                        <td/>
                        <%
                            }
                        %>
                        <td>
                            <%=tAbs.getHasAttachments()%>
                        </td>
                        <td>
                            <%=tAbs.getHasComments()%>
                        </td>
                    </tr>
                    <%
                            }
                        }
                    %>
                    </tbody>
                </table>
            </div>

        </div>
    </div>
</fmt:bundle>